/* feu de frt */
#include"allegro.h"
#include <string.h>

#define ECRAN_X	800
#define ECRAN_Y 600
#define MODE    GFX_AUTODETECT_WINDOWED

#define BOIS	1
#define FEU		2
#define CENDRE	3

#define TX		200
#define TY		150
int P[TX][TY];
int NP[TX][TY];

#define pasx	ECRAN_X/TX
#define pasy	ECRAN_Y/TY
#define Y(n)	(n)*pasy
#define X(n)	(n)*pasx

#define MAXI	1000
#define SEUIL	0.6*MAXI

int cmpt_feu;
PALETTE pal;
BITMAP *page;

/***********************************************************
***********************************************************/
void affiche_plan(BITMAP *bmp)
{
int i, j;

	clear(bmp);
	for(i=0; i < TX; i++)
		for(j=0; j<TY; j++)
			rectfill(bmp, X(i),Y(j), X(i+1),Y(j+1), P[i][j]);

}
/***********************************************************
***********************************************************/
void init_bois(void)
{
int i, j, hasard;

	for ( i = 0; i < TX; i++){
		for ( j = 0; j < TY; j++){
			hasard = rand()%MAXI;
			if(hasard < SEUIL )
				P[i][j] = BOIS;
			else
				P[i][j] = 0;	
		}
	}
}
/***********************************************************
***********************************************************/
int init_feu(void)
{
int i, j, cmpt;

	for( i = 1, j = 0, cmpt=0; j < TY;j++){		
		if( P[i][j]==BOIS ){
			P[i][j]=FEU;
			cmpt++;
		}
	}
	memcpy(NP,P,sizeof(int)*TY*TX);

	return cmpt;
}
/***********************************************************
***********************************************************/
void propagation(void)
{
int i,ia,ib;
int j,ja,jb;
	
	for ( i=1; i<TX; i++){
		ia=(i+1)%TX;
		ib=((i-1)+TX)%TX;
		for (j=0; j<TY; j++){
			ja=(j+1)%TY;
			jb=((j-1)+TY)%TY;
			if( P[i][j]== BOIS ){
				if( (P[ia][j]==FEU) || (P[i][jb]==FEU) ||
					(P[ib][j]==FEU) || (P[i][ja]==FEU)  ){
					NP[i][j]=FEU;
					cmpt_feu++;
				}
			}
			else if(P[i][j]==FEU){
				NP[i][j]=CENDRE;
				cmpt_feu--;			
			}	
		}
	}
	for(i=0;i<TX;i++)
		memcpy(P[i],NP[i],sizeof(int)*TY);
}
/***********************************************************
***********************************************************/
int main ()
{
	allegro_init();
	install_keyboard(); 
	srand(time(NULL));

	set_gfx_mode(MODE, ECRAN_X, ECRAN_Y, 0, 0);
	page =create_bitmap(ECRAN_X,ECRAN_Y);

	//PALETTE 
	pal[0].r=0;
	pal[0].g=0;
	pal[0].b=0;

	pal[1].r=0;
	pal[1].g=0;
	pal[1].b=63;

	pal[2].r=63;
	pal[2].g=0;
	pal[2].b=0;

	pal[3].r=0;
	pal[3].g=63;
	pal[3].b=0;

	pal[4].r=0;
	pal[4].g=0;
	pal[4].b=63;

	set_pallete(pal);
	cmpt_feu=0;

	while ( ! key[KEY_ESC] ){

		if ( key[KEY_ENTER]){			
			init_bois();
			cmpt_feu = init_feu();	
		}
		if(cmpt_feu){			
			propagation();
			affiche_plan(page);
			blit(page,screen, 0,0,0,0, ECRAN_X,ECRAN_Y);
		}		
	}
	return 0;
}
END_OF_MAIN();
/***********************************************************
***********************************************************/

